# DHCP Server Configuration file.
#   see /usr/share/doc/dhcp*/dhcpd.conf.sample
#
### iPXE-specific options
#
# http://www.ipxe.org/howto/dhcpd
#
option space ipxe;
option ipxe-encap-opts code 175 = encapsulate ipxe;
option ipxe.priority code 1 = signed integer 8;
option ipxe.keep-san code 8 = unsigned integer 8;
option ipxe.skip-san-boot code 9 = unsigned integer 8;
option ipxe.syslogs code 85 = string;
option ipxe.cert code 91 = string;
option ipxe.privkey code 92 = string;
option ipxe.crosscert code 93 = string;
option ipxe.no-pxedhcp code 176 = unsigned integer 8;
option ipxe.bus-id code 177 = string;
option ipxe.bios-drive code 189 = unsigned integer 8;
option ipxe.username code 190 = string;
option ipxe.password code 191 = string;
option ipxe.reverse-username code 192 = string;
option ipxe.reverse-password code 193 = string;
option ipxe.version code 235 = string;
option iscsi-initiator-iqn code 203 = string;

# Feature indicators
option ipxe.pxeext code 16 = unsigned integer 8;
option ipxe.iscsi code 17 = unsigned integer 8;
option ipxe.aoe code 18 = unsigned integer 8;
option ipxe.http code 19 = unsigned integer 8;
option ipxe.https code 20 = unsigned integer 8;
option ipxe.tftp code 21 = unsigned integer 8;
option ipxe.ftp code 22 = unsigned integer 8;
option ipxe.dns code 23 = unsigned integer 8;
option ipxe.bzimage code 24 = unsigned integer 8;
option ipxe.multiboot code 25 = unsigned integer 8;
option ipxe.slam code 26 = unsigned integer 8;
option ipxe.srp code 27 = unsigned integer 8;
option ipxe.nbi code 32 = unsigned integer 8;
option ipxe.pxe code 33 = unsigned integer 8;
option ipxe.elf code 34 = unsigned integer 8;
option ipxe.comboot code 35 = unsigned integer 8;
option ipxe.efi code 36 = unsigned integer 8;
option ipxe.fcoe code 37 = unsigned integer 8;

# speed-up for no proxydhcp user
option ipxe.no-pxedhcp 1;

 option client-arch code 93 = unsigned integer 16;
# common settings
authoritative;
ddns-update-style interim;
ignore client-updates;

allow booting;
allow bootp;

set vendorclass = option vendor-class-identifier;

{% for subnet in subnets %}
subnet {{subnet.prefix}} netmask {{subnet.mask}} {

        option subnet-mask {{subnet.mask}};{%- if subnet.gateway is defined %}
        option routers {{subnet.gateway}};
        {% endif %}{%- if subnet.dnsServers is defined %}
        option domain-name-servers {{subnet.dnsServers | join(', ')}};
        {% endif %}
        {% if subnet.start is defined and subnet.start != "" %}
        range {{subnet.start}} {{subnet.end}};

        default-lease-time 21600;
        max-lease-time 43200;
        {% endif %}
        {%- if subnet.pxe is defined and subnet.pxe %}
        next-server {{ironic.ip}};

        if exists user-class and option user-class = "iPXE" {
            filename "http://{{ironic.ip}}:{{ironic.port}}/boot.ipxe";
        } else {
            if option client-arch != 00:00 {
              filename "ipxe.efi";
            } else {
              filename "undionly.kpxe";
            }
        }
        deny unknown-clients;
        {% endif %}
}
{% endfor %}

{%- if hosts is defined %}
group {
  {% for host in hosts %}
  host {{host.name}} {
    hardware ethernet {{host.mac}};{%- if host.ip  is defined %}
    fixed-address {{host.ip}};
    {% endif %}
  }
  {% endfor %}
}
{% endif %}
